unit T_BiancoDOS;
{
                                   \\\\\/////
                                   /  _   _  \
                                  (| (.) (.) |)
 _______________________________.OOOo__( )__oOOO.______________________________
|                                                                              |
|                               This is my Tcomponent                          |
|                                    Ciao Marco                                |
|                              Email bianco@arcanet.it                         |
|                                                                              |
| DATA:      INIZIO:    FINE:      LAVORO:                                     |
|                                                                              |
| 10-09-97,  19:19:55,  03:33:36   INIZIATO A CONVERTIRE IL VECCHIO FILE.      |
|_______________________________.oooO__________________________________________|
                                (   )        Oooo.
                                 \ (         (   )
                                  \_)         ) /
                                             (_/

}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,ExtCtrls;

CONST
 COLORI:ARRAY[0..15] OF TCOLOR = (CLBLACK,CLBLUE,CLGREEN,CLMAROON,CLRED,CLOLIVE,CLNAVY,
                                  CLPURPLE,CLTEAL,CLGRAY,CLSILVER,
                                  CLLIME,CLFUCHSIA,
                                  CLAQUA,CLYELLOW,CLWHITE);
 LINES=24;
 ROWS=79;
TYPE
  REC=RECORD
   C:CHAR;
   F:TCOLOR;
   B:TCOLOR;
  END;
  WIN=RECORD
   AX:INTEGER;
   AY:INTEGER;
   BX:INTEGER;
   BY:INTEGER;
  END;

  TBiancoDOS = class(TGraphicControl)
  private
    { Private declarations }
    TIM:TTIMER;
    BC,FC:TCOLOR; //BACKGROUND AND FORE COLOR
    SC:ARRAY[0..ROWS,0..LINES] OF REC;
    _W,_H,PX,PY:INTEGER;//POSITION OF THE POINTER
    _WIN:WIN;
    Procedure Pop;
    PROCEDURE CLEAR;
    PROCEDURE SCROLL;
    PROCEDURE AVANZAX;
    PROCEDURE AVANZAY;
    PROCEDURE LETTERA(X,Y:INTEGER);
    PROCEDURE VEDICUR(SENDER:TOBJECT);
    procedure Delay(msecs:WORD);
  protected
    { Protected declarations }
   procedure Paint; override;
  public
    { Public declarations }
   constructor Create(AOwner: TComponent); override;
   DESTRUCTOR DESTROY; OVERRIDE;
   Function WhereX:Integer;
   Function WhereY:Integer;
   PROCEDURE CLRSCR;
   PROCEDURE CLREOL;
   PROCEDURE WRITE(S:STRING);
   PROCEDURE WRITELN(S:STRING);
   PROCEDURE GOTOXY(X,Y:INTEGER);
   PROCEDURE BACKCOLOR(C:INTEGER);
   PROCEDURE TEXTCOLOR(C:INTEGER);
   PROCEDURE WINDOW(A1,A2,A3,A4:INTEGER);
  published
    { Published declarations }
   PROPERTY Font;
  end;

procedure Register;

implementation

procedure TBIANCODOS.Delay(msecs:WORD);
 var
   FirstTickCount:longint;
 begin
  FirstTickCount:=GetTickCount;
  repeat
  // Application.ProcessMessages;
  until ((GetTickCount-FirstTickCount) >= Longint(msecs));
 end;

PROCEDURE TBIANCODOS.VEDICUR(SENDER:TOBJECT);
 VAR
  A,X,Y:INTEGER;
  C1,C2:TCOLOR;
 BEGIN
  C1:=SC[PX+_WIN.AX,PY+_WIN.AY].F;
  C2:=SC[PX+_WIN.AX,PY+_WIN.AY].B;
  IF C1=C2 THEN
   BEGIN
    A:=16;
    REPEAT
     DEC(A);
    UNTIL COLORI[A]<>C2;
    C1:=COLORI[A];
   END;
  X:=(PX+_WIN.AX)*_W;
  Y:=(PY+_WIN.AY)*_H;
  CANVAS.PEN.COLOR:=C1;
  CANVAS.MOVETO(X,Y);
  CANVAS.LINETO(X,Y+_H);
  DELAY(150);
  CANVAS.PEN.COLOR:=C2;
  CANVAS.LINETO(X,Y-1);
 END;

PROCEDURE TBiancoDOS.CLEAR;
 VAR
  X,Y:INTEGER;
 BEGIN
  FOR X:=_WIN.AX TO _WIN.BX-1 DO
   FOR Y:=_WIN.AY TO _WIN.BY-1 DO
    BEGIN
     SC[X,Y].C:=#32;
     SC[X,Y].B:=BC;
    END;
 END;

PROCEDURE TBIANCODOS.SCROLL;
 VAR
  X,Y:INTEGER;
 BEGIN
  LockWindowUpdate(Canvas.Handle);
  FOR Y:=_WIN.AY+1 TO _WIN.BY-1 DO
   FOR X:=_WIN.AX TO _WIN.BX-1 DO
    if (SC[X,Y-1].c<>SC[X,Y].c) or (SC[X,Y-1].b<>SC[X,Y].b) or (SC[X,Y-1].f<>SC[X,Y].f) then
     begin
      SC[X,Y-1]:=SC[X,Y];
      Lettera(x,y-1);
     end;
  FOR X:=_WIN.AX TO _WIN.BX-1 DO
   BEGIN
    SC[X,_WIN.BY-1].C:=#32;
    SC[X,_WIN.BY-1].B:=BC;
    LETTERA(X,_WIN.BY-1);
   END;
  LockWindowUpdate(0);
 END;

Procedure TBiancoDos.Pop;
 Begin
  IF RANDOM(600)=0 THEN
   SHOWMESSAGE('Bianchini Marco'+#13+'E-Mail bianco@arcanet.it');
End;

PROCEDURE TBiancoDOS.LETTERA(X,Y:INTEGER);
 BEGIN
  CANVAS.FONT.COLOR:=SC[X,Y].F;
  CANVAS.BRUSH.COLOR:=SC[X,Y].B;
  CANVAS.TEXTOUT(X*_W,Y*_H,SC[X,Y].C);
 END;

PROCEDURE TBiancoDOS.AVANZAX; //AVANZA LA POSIZIONE DEL CURSORE
 BEGIN
  INC(PX);
  IF PX=_WIN.BX-_WIN.AX THEN
   BEGIN
    PX:=0;
    AVANZAY;
   END;
 END;

PROCEDURE TBiancoDOS.AVANZAY; //AVANZA LA POSIZIONE DEL CURSORE
 BEGIN
  INC(PY);
  IF PY=_WIN.BY-_WIN.AY THEN
   BEGIN
    SCROLL;
    PY:=_WIN.BY-_WIN.AY-1;
   END;
 END;

//METHODS
PROCEDURE TBiancoDOS.CLRSCR;
 BEGIN
  Pop;
  CLEAR;
  CANVAS.PEN.COLOR:=BC;
  CANVAS.BRUSH.COLOR:=BC;
  CANVAS.RECTANGLE(_WIN.AX*_W,_WIN.AY*_H,_WIN.BX*_W,_WIN.BY*_H);
  PX:=0;
  PY:=0;
 END;

PROCEDURE TBIANCODOS.CLREOL;
 VAR
  X:INTEGER;
 BEGIN
  Pop;
  LockWindowUpdate(Canvas.Handle);
  FOR X:=PX+_WIN.AX TO _WIN.BX-1 DO
   BEGIN
    SC[X,PY+_WIN.AY].C:=#32;
    SC[X,PY+_WIN.AY].B:=BC;
    SC[X,PY+_WIN.AY].F:=FC;
    LETTERA(X,PY+_WIN.AY);
   END;
  LockWindowUpdate(0);
 END;

PROCEDURE TBIANCODOS.TEXTCOLOR(C:INTEGER);
 BEGIN
  Pop;
  FC:=COLORI[C];
 END;

PROCEDURE TBIANCODOS.BACKCOLOR(C:INTEGER);
 BEGIN
  Pop;
  BC:=COLORI[C];
 END;

FUNCTION TBIANCODOS.WHEREX:INTEGER;
 BEGIN
  Pop;
  RESULT:=PX;
 END;

FUNCTION TBIANCODOS.WHEREY:INTEGER;
 BEGIN
  Pop;
  RESULT:=PY;
 END;

PROCEDURE TBIANCODOS.GOTOXY(X,Y:INTEGER);
 BEGIN
  Pop;
  PX:=X;
  PY:=Y;
 END;

PROCEDURE TBIANCODOS.WRITE(S:STRING);
 VAR
  A,C:INTEGER;
 BEGIN
  Pop;
  LockWindowUpdate(Canvas.Handle);
  C:=LENGTH(S);
  IF C>0 THEN
   FOR A:=1 TO C DO
    BEGIN
     SC[PX+_WIN.AX,PY+_WIN.AY].C:=S[A];//,A,1));
     SC[PX+_WIN.AX,PY+_WIN.AY].B:=BC;
     SC[PX+_WIN.AX,PY+_WIN.AY].F:=FC;
     LETTERA(PX+_WIN.AX,PY+_WIN.AY);
     AVANZAX;
    END;
  LockWindowUpdate(0);
 END;

PROCEDURE TBIANCODOS.WRITELN(S:STRING);
 BEGIN
  Pop;
  WRITE(S);
  PX:=0;
  AVANZAY;
 END;

PROCEDURE TBIANCODOS.WINDOW(A1,A2,A3,A4:INTEGER);
 BEGIN
  Pop;
  WITH _WIN DO
   BEGIN
    AX:=A1;
    AY:=A2;
    BX:=A3;
    BY:=A4;
   END;
  GOTOXY(0,0);
 END;

// INHERITED
PROCEDURE TBIANCODOS.PAINT;
 VAR
  X,Y:INTEGER;
 BEGIN
  IF RANDOM(200)=0 THEN
   SHOWMESSAGE('Bianchini Marco'+#13+'E-Mail bianco@arcanet.it');

  LockWindowUpdate(Canvas.Handle);
  INHERITED PAINT;
  CANVAS.FONT:=SELF.FONT;
  _H:=CANVAS.TEXTHEIGHT('O');
  _W:=CANVAS.TEXTWIDTH('O');
  HEIGHT:=_H*LINES;
  WIDTH:=_W*ROWS;
  WITH CANVAS DO
   FOR Y:=0 TO LINES DO
    FOR X:=0 TO ROWS DO
     LETTERA(X,Y);
  LockWindowUpdate(0);
 END;

Constructor TBiancoDOS.Create(AOwner: TComponent);
 Begin
  Inherited Create(Aowner);
  FC:=CLWHITE;
  BC:=CLBLACK;
  PX:=0;
  PY:=0;
  CLEAR;
  IF NOT (CSDESIGNING IN COMPONENTSTATE) THEN
   BEGIN
    TIM:=TTIMER.CREATE(SELF);
    TIM.INTERVAL:=300;
    TIM.ENABLED:=TRUE;
    TIM.ONTIMER:=VEDICUR;
   END;
  RANDOMIZE;
  _WIN.AX:=0;
  _WIN.AY:=0;
  _WIN.BX:=ROWS;
  _WIN.BY:=LINES;
 End;

DESTRUCTOR TBIANCODOS.DESTROY;
 BEGIN
  IF NOT (CSDESIGNING IN COMPONENTSTATE) THEN
   BEGIN
    TIM.ENABLED:=FALSE;
    TIM.DESTROY;
   END;
  INHERITED DESTROY;
 END;

procedure Register;
begin
  RegisterComponents('Bianco', [TBiancoDOS]);
end;

end.
